#include <stdio.h>
#include <ctype.h>

#include <sys/types.h>
#include <sys/stat.h>
#include <signal.h>

#include <sys/time.h>
#include <sys/types.h>
#include <sys/resource.h>
#include <unistd.h>
#if defined(sparc) && defined(sun4c)
#include <sys/rusage.h>
#endif


#include "irc.h"
#include "server.h"
#include "edit.h"
#include "crypt.h"
#include "vars.h"
#include "ircaux.h"
#include "lastlog.h"
#include "window.h"
#include "screen.h"
#include "whois.h"
#include "hook.h"
#include "input.h"
#include "ignore.h"
#include "keys.h"
#include "names.h"
#include "alias.h"
#include "history.h"
#include "funny.h"
#include "ctcp.h"
#include "dcc.h"
#include "translat.h"
#include "output.h"
#include "exec.h"
#include "notify.h"
#include "numbers.h"
#include "status.h"
#include "list.h"
#include "timer.h"
#include "pluto.h"
#include "userlist.h"

extern char *last_msg, *last_notice, *invite_channel;
extern int user_count;
extern int shit_count;
extern int bot_count;
extern time_t start_time;
extern NickList *Bot_list;

ChannelList *statchan_list = NULL;
ChannelList default_statchan = { 0 };
char *awaymsg = NULL;

char *convert_time(time_t ltime)
{
	time_t  days = 0,hours = 0,minutes = 0,seconds = 0;
	static char buffer[BIG_BUFFER_SIZE+1];
	*buffer = '\0';
	seconds = ltime % 60;
	ltime = (ltime - seconds) / 60;
	minutes = ltime%60;
	ltime = (ltime - minutes) / 60;
	hours = ltime % 24;
	days = (ltime - hours) / 24;
	sprintf(buffer, "%2ldd %2ldh %2ldm %2lds", days, hours, minutes, seconds);
	return(*buffer ? buffer : "");
}

void do_uptime( char *command, char *args, char *subargs)
{
	say("--------------------- \002%s Client Statistics\002 --------------------", version);
	say("\002Client Version\002: %s", irc_version);
	say("\002Client Running\002 since %s ", my_ctime(start_time));
	say("\002Client Uptime\002: %s.", convert_time(time(NULL)-start_time));
	say("\002Current Username\002: %s", username);
	say("\002Current realname\002: %s", realname);
	say("\002Last Message\002: %s", last_msg? last_msg: "\002None\002");
	say("\002Last Notice\002: %s", last_notice?last_notice:"\002None\002");
	say("\002Last Channel invited\002 to %s", invite_channel? invite_channel:"\002None\002");
	say("\002Total Users\002 on Userlist: %d", user_count);
	say("\002Total Users\002 on shitlist: %d", shit_count);
	say("\002Total Botz \002 on Botlist:  %d", bot_count);
}

/* extern_write -- controls whether others may write to our terminal or not. */
/* This is basically stolen from bsd -- so its under the bsd copyright */
#ifdef __STDC__
void extern_write (char *command, char *args, char *subargs)
#else
void	extern_write (command, args, subargs)
char *command, *arg, *subargs;
#endif
{
	char *tty;
	struct stat sbuf;
	const int OTHER_WRITE = 020;

	if (!(tty = ttyname(2)))
	{
		yell("Internal error: notify %s", "edwac@sasknet.sk.ca");
		yell("Error in ttyname()");
		return;
	}
	if (stat(tty, &sbuf) < 0)
	{
		yell("Internal error: notify %s", "edwac@sasknet.sk.ca");
		yell("Error in stat()");
		return;
	}
	if (!args || !*args)
	{
		if (sbuf.st_mode & 020)
			say("Mesg is 'y'");
		else
			say("Mesg is 'n'");
		return;
	}
	switch (args[0])
	{
		case 'y' :
			if (chmod(tty, sbuf.st_mode | OTHER_WRITE) < 0)
			{
				yell("Sorry, couldnt set your tty's mode");
				return;
			}
			break;
		case 'n' :
			if (chmod(tty, sbuf.st_mode &~ OTHER_WRITE) < 0)
			{
				yell("Sorry, couldnt set your tty's mode");
				return;
			}
			break;
		default :
			say("Usage: /MESG [Y|N]");
			break;
	}
}

int timer_unban _((void *args))
{
	char *p = (char *)args;
	char *channel;
	char *nick;

	channel = next_arg(p, &p);
	nick = next_arg(p, &p);
	send_to_server("MODE %s -b %s", channel, nick);
	new_free(&channel);
	return 0;
}

int timer_idlekick _((void *args))
{
char *channel = (char *)args;
ChannelList *tmp;
int kick_count = 0;
NickList *user = NULL, *bot = NULL;
	if ((tmp = lookup_channel(channel, from_server, CHAN_NOUNLINK)) && are_you_opped(channel) && tmp->max_idle && tmp->check_idle)
	{
		NickList *nick;
		for (nick = tmp->nicks; nick; nick = nick->next)
		{
			user = nickinlist(user_list, nick->nick, nick->host);
			if (user && check_channel_match(user->channels, channel))
				continue;			
			bot = nickinlist(Bot_list, nick->nick, nick->host);
			if (bot && check_channel_match(bot->channels, channel))
				continue;
			if (!my_stricmp(nick->nick, get_server_nickname(from_server)))
				continue;
			if (nick->chanop && !get_int_var(KICK_OPS_VAR))
				continue;
			if (time(NULL) - nick->idle_time >= tmp->max_idle)
			{
				if (kick_count <= get_int_var(MAX_IDLEKICKS_VAR))
				{
					char *p = NULL;
					malloc_sprintf(&p, "%s %s*!*%s", channel, nick->nick, nick->host);
					send_to_server("MODE %s +b %s*!*%s", channel, nick->nick, nick->host);
					send_to_server("KICK %s %s :\002%s\002: (Idle Channel User)", channel, nick->nick, version);
					add_timer(-1, 60, timer_unban, p, NULL);
				}
				else
					break;
				kick_count++;
			}
		}
	}		
	if (tmp && tmp->max_idle && tmp->check_idle)
		add_timer(-1, get_int_var(IDLE_CHECK_VAR), timer_idlekick, channel, NULL);
	else
		new_free(&channel);

	return 0;
}

void addidle (char *command, char *args, char *subargs )
{
time_t default_idle = 10 * 60;
char *channel = NULL, *p;
time_t seconds = 0;
ChannelList *tmp, *new = NULL;

	if (args && *args)
	{
		p = next_arg(args, &args);
		if (*p == '#')
			malloc_sprintf(&channel, "%s", p);
		else
			malloc_sprintf(&channel, "#%s", p); 
		if (args && *args)
			seconds = atol(args);

		if (seconds < default_idle)
			seconds = default_idle;

		if (!(new = (ChannelList *)find_in_list((List **)&statchan_list, channel, 0)))
		{
			new = (ChannelList *)new_malloc(sizeof(ChannelList));
			memcpy(new, &default_statchan, sizeof(ChannelList));
			malloc_strcpy(&new->channel, channel);
			get_time(&new->channel_create);
			add_to_list((List **)&statchan_list, (List *)new);
		} 
		new->max_idle = seconds;
		new->check_idle = (my_strnicmp(command, "UN", 2) == 0) ? 0: 1;

		if (!new->check_idle)
		{
				new_free(&channel);
		} 
		else
		{
			if ((tmp = lookup_channel(channel, from_server, CHAN_NOUNLINK)))
			{
				if (new && new->check_idle)
				{
					tmp->max_idle = new->max_idle;
					tmp->check_idle = new->check_idle;
					add_timer(-1, get_int_var(IDLE_CHECK_VAR), timer_idlekick, channel, NULL);
					bitchsay("Idle checking turned %s for %s %d mins",tmp->check_idle? "On":"Off", channel, tmp->max_idle/60); 
				} 
			} else
				new_free(&channel);
		}
	} else
		bitchsay("AddIdle <#channel> [seconds] - default %d mins", default_idle / 60);
}

void showidle (char *command, char *args, char *subargs )
{
ChannelList *tmp;
char *channel = NULL, *p;
	if (args && *args)
		p = next_arg(args, &args);
	else
		p = get_channel_by_refnum(0);

	if (!p)
		return;
		
	if (*p != '#')
	{
		malloc_sprintf(&channel, "#%s", p);
	} else
		malloc_strcpy(&channel, p);

	if ((tmp = lookup_channel(channel, from_server, CHAN_NOUNLINK)))
	{
		NickList *nick;
		time_t ltime;

		bitchsay("Idle check for %s Max Idle Time [ %s ]", channel,convert_time(tmp->max_idle) );
		for (nick = tmp->nicks; nick; nick = nick->next)
		{
			ltime = time(NULL) - nick->idle_time;
			put_it("%-20s Idle: [%s]", nick->nick, convert_time(ltime));
		}
	} else
		not_on_a_channel();

	new_free(&channel);
}

void kickidle (char *command, char *args, char *subargs )
{
char *channel = NULL;
char *p = NULL;
ChannelList *tmp;
int kick_count = 0;
	if (args && *args)
		p = next_arg(args, &args);

	if (!p)
	{
		bitchsay("Specify a channel for idlekick");
		return;
	}
		
	if (*p != '#')
	{
		malloc_sprintf(&channel, "#%s", p);
	} else
		malloc_strcpy(&channel, p);

	
	if ((tmp = lookup_channel(channel, from_server, CHAN_NOUNLINK)) && are_you_opped(channel) && tmp->max_idle)
	{
		NickList *nick;
		NickList *user, *bot;
		for (nick = tmp->nicks; nick; nick = nick->next)
		{
			user = nickinlist(user_list, nick->nick, nick->host);
			if (user && check_channel_match(user->channels, channel))
				continue;			
			bot = nickinlist(Bot_list, nick->nick, nick->host);
			if (bot && check_channel_match(bot->channels, channel))
				continue;
			if (time(NULL) - nick->idle_time >= tmp->max_idle)
			{
				if (kick_count <= get_int_var(MAX_IDLEKICKS_VAR))
					send_to_server("KICK %s %s :\002%s\002: (Idle Channel User)", channel, nick->nick, version);
				else
					bitchsay(" found idle user %-12s channel %s", nick->nick, channel);
				kick_count++;
			}
		}
	} else
		bitchsay("Maybe try /addidle first");

	new_free(&channel);
}

void save_idle(FILE *output)
{
ChannelList *chan;
int count = 0;
	if (!output)
		return;
	fprintf(output, "# %s Idle Channel list\n", version);
	for (chan = statchan_list; chan; chan = chan->next)
	{
		if (chan->max_idle)
		{
			fprintf(output, "ADDIDLE %s %d\n", chan->channel, (int)chan->max_idle); 
			count++;
		}
	}
	if (do_hook(SAVEFILE_LIST, "Idle %d", count))
		bitchsay("Saved %d Idle channels", count);
}

void channel_stats(char *command, char *args, char * subargs)
{
ChannelList *tmp, *new = NULL;
char *channel;

	if (args && *args)
		channel = next_arg(args, &args);
	else
		channel = get_channel_by_refnum(0);

	if (!channel)
	{
		not_on_a_channel();
		return;
	}
	if (my_strnicmp(channel, "-A", 2)==0)
	{
	
	int stats_ops= 0, stats_dops = 0, stats_bans = 0, stats_unbans = 0;
	int stats_topics = 0, stats_kicks = 0, stats_pubs = 0, stats_parts = 0;
	int stats_signoffs = 0, stats_joins = 0;
	int total_nicks = 0, max_nicks = 0, total_bans = 0, max_bans = 0;
	int stats_sops = 0, stats_sdops = 0, stats_sbans = 0, stats_sunbans = 0;	
	NickList *l; 
	BanList *b;
	long nick_mem = 0, chan_mem = 0, ban_mem = 0;
	
		for (tmp = statchan_list; tmp; tmp = tmp->next)
		{

	if (from_server >= 0)
	{
		for (new = server_list[from_server].chan_list; new; new = new->next)
		{		
			for (l = new->nicks; l; l = l->next)
				nick_mem += sizeof(NickList);
			for (b = new->bans; b; b = b->next)
				ban_mem += sizeof(BanList);
			put_it("  MEM usage: Total: %ld bytes   [Nicks %ld b Chan %ld b Bans %ld b]", nick_mem+sizeof(ChannelList)+ban_mem, nick_mem, sizeof(ChannelList), ban_mem);
		}
	}
			chan_mem += sizeof(ChannelList);
			stats_ops += tmp->stats_ops;
			stats_dops += tmp->stats_dops;
			stats_bans += tmp->stats_bans;
			stats_unbans += tmp->stats_unbans;
			stats_topics += tmp->stats_topics;
			stats_kicks += tmp->stats_kicks;
			stats_pubs += tmp->stats_pubs;
			stats_parts += tmp->stats_parts;
			stats_signoffs += tmp->stats_signoffs;
			stats_joins += tmp->stats_joins;

			total_nicks += tmp->totalnicks;
			max_nicks += tmp->maxnicks;
			total_bans += tmp->totalbans;
			max_bans += tmp->maxbans;
			stats_sops += tmp->stats_sops;
			stats_sdops += tmp->stats_sdops;
			stats_sbans += tmp->stats_sbans;
			stats_sunbans += tmp->stats_sunbans;						
		}
		bitchsay("Stats for all channels since %s", my_ctime(start_time));
		put_it("  Time connected %s", convert_time(time(NULL)-start_time));
		put_it("  MEM Usage: Total: %ld bytes   [Nicks %ld b Chan %ld b Bans %ld b]", nick_mem+chan_mem+ban_mem, nick_mem, chan_mem, ban_mem);
		put_it("I've seen - ");
		put_it("   %03d - ops       %03d - de-ops    %03d - bans     %03d - unbans ",stats_ops, stats_dops, stats_bans, stats_unbans);
		put_it("   %03d - topics    %03d - kicks     %03d - publics  %03d - parts", stats_topics, stats_kicks, stats_pubs, stats_parts);
		put_it("   %03d - signoffs  %03d - joins", stats_signoffs, stats_joins);
		put_it("   %03d - serv ops  %03d - serv deop %03d - serv ban %03d - serv unban", stats_sops, stats_sdops,stats_sbans, stats_sunbans);
		put_it("   %03d - total nicks  %03d - max nicks", total_nicks, max_nicks);
		put_it("   %03d - max bans     %03d - total bans", max_bans, total_bans);
		bitchsay("End of All channel stats");
		return;		
	}
	if ((tmp = (ChannelList *)find_in_list((List **)&statchan_list, channel, 0)))
	{	
		NickList *l; long nick_mem = 0, ban_mem = 0; BanList *b;
		bitchsay("Channel stats for channel: %s",channel); 
		if (from_server >=0)
			new = (ChannelList *)find_in_list((List **)&(server_list[from_server].chan_list), channel, 1);
		put_it("Since joining %s on %s", channel, my_ctime(tmp->channel_create.tv_sec)); 
		put_it("  Time on channel is %s", convert_time(time(NULL)-tmp->channel_create.tv_sec));
		if (new)
		{
			for (l = new->nicks; l; l = l->next)
				nick_mem += sizeof(NickList);
			for (b = new->bans; b; b = b->next)
				ban_mem += sizeof(BanList);
			put_it("  MEM usage: Total: %ld bytes   [Nicks %ld b Chan %ld b Bans %ld b]", nick_mem+sizeof(ChannelList)+ban_mem, nick_mem, sizeof(ChannelList), ban_mem);
		}
		put_it("I've seen - ");
		put_it("   %03d - ops       %03d - de-ops    %03d - bans     %03d - unbans ",tmp->stats_ops, tmp->stats_dops, tmp->stats_bans, tmp->stats_unbans);
		put_it("   %03d - topics    %03d - kicks     %03d - publics  %03d - parts", tmp->stats_topics, tmp->stats_kicks, tmp->stats_pubs, tmp->stats_parts);
		put_it("   %03d - signoffs  %03d - joins", tmp->stats_signoffs, tmp->stats_joins);
		put_it("   %03d - serv ops  %03d - serv deop %03d - serv ban %03d - serv unban", tmp->stats_sops, tmp->stats_sdops,tmp->stats_sbans, tmp->stats_sunbans);
		put_it("   %03d - total nicks  %03d - max nicks", tmp->totalnicks, tmp->maxnicks);
		put_it("   %03d - max bans     %03d - total bans", tmp->maxbans, tmp->totalbans);

		if (new)
		{
			put_it("  There is %s limit and limit checking is %s", new->limit ? ltoa(new->limit): "no", new->tog_limit?"Enabled":"Disabled");
			put_it("  I %s scanning and idle checking is %s", new->do_scan? "am":"am not",new->check_idle?"Enabled":"Disabled");
		}

		bitchsay("End of channel stats for %s", channel);
	}
	else
		bitchsay("No such channel in memory");
}

void update_stats(int what, char *channel, char *who)
{
ChannelList *tmp, *stats;
NickList *nick;
int i_left =0;

	tmp = lookup_channel(channel, from_server, CHAN_NOUNLINK);
	if (!tmp)
		return;
	nick = (NickList *)find_in_list((List **)&tmp->nicks, who, 1);

	stats = (ChannelList *)find_in_list((List **)&statchan_list, channel, 0);

	if (!nick)
		return;
	if (!my_stricmp(who, get_server_nickname(from_server)))
		i_left = 1;

	switch (what)
	{
		case KICK_LIST:
		{
			if (stats)
			{
				stats->stats_kicks++;
				stats->totalnicks--;
				if (i_left)
					stats->totalnicks = 0;
			}
			nick->kickcount++;
			nick->kicktime = time(NULL);
			break;
		}

		case LEAVE_LIST:
		{
			if (stats) 
			{
				stats->stats_parts++;
				stats->totalnicks--;
				if (i_left)
					stats->totalnicks = 0;
			}
			break;
		}
		case JOIN_LIST:
		{
			if (stats) 
			{
				stats->stats_joins++;
				stats->totalnicks++;
				if (stats->totalnicks > stats->maxnicks)
				{
					stats->maxnicks = stats->totalnicks;
					stats->maxnickstime = time(NULL);
				}
			}
			break;
		}
		case CHANNEL_SIGNOFF_LIST:
		{
			if (stats) 
			{
				stats->stats_signoffs++;
				stats->totalnicks--;
				if (i_left)
					stats->totalnicks = 0;
			}
			break;
		}
		case PUBLIC_LIST:
		case PUBLIC_OTHER_LIST:
		case PUBLIC_NOTICE_LIST:
		case NOTICE_LIST:
		{
			if (stats) stats->stats_pubs++;
			nick->idle_time = nick->floodtime = time(NULL);
			nick->floodcount++;
			break;
		}
		case TOPIC_LIST:
		{
			if (stats) stats->stats_topics++;
			break; 
		}
		default:
			bitchsay("Illegal what %d passed to update_stats", what);
			break;
	}
}

void usage _((char *command, char *args, char *subargs))
{
#if !defined(sparc) || !defined(__sparc__)
struct rusage r_usage;
	if ((0 == getrusage(RUSAGE_SELF, &r_usage)))
	{
		/* struct timeval ru_utime; user time used 
                 * struct timeval ru_stime;  system time used 
		 */                
		int secs = r_usage.ru_utime.tv_sec + r_usage.ru_stime.tv_sec;
		if (secs == 0)
			secs =1;
		
		bitchsay("CPU Usage:  Secs %d:%d     [User %d:%d   System %d:%d]",secs/60,secs%60,r_usage.ru_utime.tv_sec/60, r_usage.ru_utime.tv_sec%60,r_usage.ru_stime.tv_sec/60, r_usage.ru_stime.tv_sec%60);
		bitchsay("MEM Usage:  MaXRSS %ld   ShMem %ld  Data %ld  Stack %ld",r_usage.ru_maxrss, r_usage.ru_ixrss, r_usage.ru_idrss,r_usage.ru_isrss);
		bitchsay("Swaps %ld   Reclaims %ld   Faults %ld",r_usage.ru_nswap, r_usage.ru_minflt, r_usage.ru_majflt);
		bitchsay("Block [in  %ld    out  %ld]",r_usage.ru_inblock, r_usage.ru_oublock);
		bitchsay("Msg [Rcv %ld    Send %ld]",r_usage.ru_msgrcv, r_usage.ru_msgsnd);
		bitchsay("Signals %ld   Context Vol. %ld   Invol %ld",r_usage.ru_nsignals, r_usage.ru_nvcsw, r_usage.ru_nivcsw);
	}
#else
	bitchsay("This function needed to be disabled on your client");
#endif
}

void add_env _((char * args))
{
char *com;
	if ((com = next_arg(args, &args)))
	{
		if (!my_stricmp(com, "AWAYMSG"))
		{
			if (from_server >=0)
				malloc_strcpy(&awaymsg, args);
		}
		else
			bitchsay("Unknown ENV var");
	}
	else
		bitchsay("NO args to ENV");		
}


char *host_match = NULL;

void stat_k_userhost(WhoisStuff *stuff, char *nick, char *args)
{
char *user;
	if (!stuff || !stuff->nick || !nick || !strcmp(stuff->user, "<UNKNOWN>") || my_stricmp(stuff->nick, nick))
	{
		say("No match for user %s", nick);
		return;
	}
	user = stuff->user;
	if (*user == '~') user++;
	if (*user == '#') user++;
	malloc_sprintf(&host_match, "*!%s@%s", user, stuff->host);
	send_to_server("STATS K");
}

void statkgrep(char *command, char *args, char *subargs)
{
char *person;
	if (args && *args)
	{
		person = next_arg(args, &args);
		if (person && *person)
		{
			if (strchr(person, '!') && strchr(person, '@'))
				malloc_strcpy(&host_match, person);
			else if (strchr(person, '@'))
				malloc_sprintf(&host_match, "*!%s", person);
			else if (strchr(person, '!'))
				malloc_sprintf(&host_match, "%s@*", person);
			else
			{
				add_to_userhost_queue(person, stat_k_userhost, person);
				return;
			}
			send_to_server("STATS K");
		}		
	}
	else
		bitchsay("Usage: /statsk nick!user@hostname");
}

int stats_k_grep(char **args)
{
/*
 * arg[1] has the banned host
 * arg[3] has the username.
 */
char *user, *host, *p;
char *nick1, *user1, *host1;
char *tmp1 = NULL;

	/* if host_match is null just return, as we are not doing a grep */
	user = args[3];
	host = args[1];
	if (!host_match || !args || !host || !*host || !user || !*user)
		return 0;

	/* break up host_match into various parts. */
	malloc_strcpy(&tmp1, host_match);
	nick1 = tmp1;
	if ((p = strchr(nick1, '!')))
		*p = '\0';
	user1 = ++p;
	if ((p = strchr(user1, '@')))
		*p = '\0';
	host1 = ++p;
		
	if (!strcmp(host, "*") || wild_match(host1, host) || wild_match(host, host1))
		if (!strcmp(user, "*") || wild_match(user1, user) || wild_match(user, user1))
		{
			bitchsay("SBan match  %s@%s : %s", user,host,args[2]?args[2]:"none");
			new_free(&host_match);
		}
	new_free(&tmp1);
	return 1;
}

void stats_k_grep_end(void)
{
	if (host_match)
		bitchsay("No match for server ban %s", host_match);
	new_free(&host_match);
}
